//Listin.java

import java.io.*;
class DimListinIncExcepcion extends Exception{
    DimListinIncExcepcion (String msg){
	super (msg);
    }
}


class Listin{
    Persona listin[];
    
    Listin (int numEltos) throws DimListinIncExcepcion{
		if (numEltos<=0)
	    	throw new DimListinIncExcepcion(" El numero de elementos del listin debe ser mayor que 0");
		listin = new Persona [numEltos];
    }
    
    /*==============*/
    void opcionAlta(){
	int i;
	boolean hueco=false;
	for (i=0; i<listin.length && !hueco; i++)
	    if (listin[i]==null)
		hueco=true;
	if (hueco){
	    i--;
	    listin[i]=new Persona();
	    System.out.println();
	    System.out.println(" La persona ha sido aadida. Sus datos son: ");
	    System.out.println(listin[i].toString());
	    System.out.println();
	}
	else
	    System.out.println(" Listin completo. Tendra que borrar alguna posicion ");
    }
    
    /*============*/
    void opcionConsulta(){
		boolean encontrado=false;
		System.out.println();
		String nombre= LectorTeclado.pedirCadena(" Introduzca el nombre del que desea consultar sus datos: ").toUpperCase();
		for (int i=0; i<listin.length && !encontrado; i++){
	    	if (listin[i]!=null && nombre.equals(listin[i].getNombre().toUpperCase()))
				if (listin[i]!=null && nombre.equals(listin[i].getNombre().toUpperCase())){
					System.out.println();
		    		System.out.println(" Los datos solicitados son:");
		    		System.out.println(" ==========================");
		    		System.out.println(listin[i].toString());
		    		encontrado=true;
				}
		}
		if(!encontrado)
	    	System.out.println(" Persona no encontrada en la lista");
    }
    
    /*============*/
    void opcionModificar(){
    	System.out.println();
    	String nombre = LectorTeclado.pedirCadena(" Introduzca el nombre que desea modificar: ").toUpperCase();
    	boolean encontrado = false;
    	int i;
    	for (i=0;i<listin.length && !encontrado; i++)
    		if (listin[i]!=null && nombre.equals(listin[i].getNombre().toUpperCase())){
    			encontrado = true;
    			System.out.println();
    			System.out.println(" Los datos antiguos de la persona son: ");
    			System.out.println(" =====================================");
    			System.out.println(listin[i].toString());
    			listin[i].modificarDatosPersona();
    			System.out.println();
    			System.out.println(" Los datos nuevos de la persona son:");
    			System.out.println(" ===================================");
    			System.out.println(listin[i].toString());
    		}
    	if (!encontrado)
    		System.out.println(" Persona no encontrada en el listin");
    	
    }
    
    /*===========*/
    void opcionConsultaTotal(){
    	System.out.println();
    	System.out.println(" Los datos de todas las personas almacenadas en su listin son: ");
    	System.out.println(" ============================================================= ");
    	for (int i=0; i<listin.length;i++)
    		if (listin[i]!=null){
    			System.out.println();
    			System.out.println(listin[i].toString());
    		}	   
    
    }
    
    /*===========*/
    void opcionBorrar(){
    	System.out.println();
    	String nombre=LectorTeclado.pedirCadena(" Introduzca el nombre que desea borrar: ").toUpperCase();
    	boolean encontrado = false;
    	int i;
    	for (i=0; i<listin.length && !encontrado; i++)
    		if (listin[i]!=null && nombre.equals(listin[i].getNombre().toUpperCase())){
    			encontrado=true;
    			System.out.println();
    			System.out.println(" Los datos de la persona a borrar son ");
    			System.out.println(listin[i].toString());
    			if (LectorTeclado.pedirConfirmacion("Esta seguro? s/n: "))
    				listin[i]=null;
    			else
    				System.out.println(" La persona no ha sido eliminada del listin");
    		}
    	if (!encontrado)
    		System.out.println(" Persona no encontrada en el listin");
    }

    /*===========*/
    void opcionSalvarDatos(){
    	String nombreFichero=LectorTeclado.pedirCadena("Introduzca el nombre del fichero desde donde se van a leer los datos");
    	try{
    		PrintWriter salida = new PrintWriter(new BufferedWriter(new FileWriter(new File (nombreFichero))));
    		for (int i=0; i<listin.length;i++){
    			if (listin[i]!=null)
    				salida.print("\n"+listin[i].getNombre()+"\n"+listin[i].getEdad()+"\n"+listin[i].getDireccion()+"\n"+listin[i].getTelefono());
    		}
    		salida.close();
    	}
    	catch (IOException ioE){
    		System.out.println("Error escribiendo en la operacion de esctritura del fichero. "+ioE.toString());
    	}
    }
    
    /*===========*/
    void opcionCargarDatos(){

    	String nombreFichero=LectorTeclado.pedirCadena("Introduzca el nombre del fichero desde donde se van a leer los datos");
    	
    	int i=0;
    	String lectura;

    	String nombre="";
    	int edad=0;
    	String direccion="";
    	String telefono="";
    	
    	try{
    	
    		BufferedReader entrada = new BufferedReader(new FileReader(new File(nombreFichero)));
    		lectura = entrada.readLine();
    		int numero=1;
    		while (lectura!=null && i<listin.length){
    			lectura = entrada.readLine();
    			switch (numero){
    				case 1: nombre =lectura;
    						System.out.println("Ha leido el nombre");
    						numero=2;
    						break;
    				case 2: edad = Integer.parseInt(lectura);
    						System.out.println("Ha leido la edad");
    						numero = 3;
    						break;
    				case 3: direccion = lectura;
    						System.out.println("Ha leido la direccion");
    						numero = 4;
    						break;
    				case 4: telefono = lectura;
    						System.out.println("Ha leido el telefono");
    						numero = 5;
    						
    				default: break;
    			}

	    		if (i>=listin.length){
	    			System.out.println("Listin lleno. No pueden cargarse mas datos");

    			}
	    		else if (numero==5){
	    			
	    			 listin[i] = new Persona(nombre,edad,direccion, telefono);
	    			 System.out.println("insertado en la posicion "+i);
	    			 numero=1;
	    			 i++;
	    		}
	    	}
	    		
	    }
	    catch(FileNotFoundException ntfE){
    		System.out.println("El fichero especificado no existe "+ntfE.toString());
    	}
    	catch(IOException ioE){
    		System.out.println("Error leyendo la operacion del fichero "+ioE.toString());
    	}
    	System.out.println("Carga realizada satisfactoriamente");
    }
	    		
    			

    /*===========*/
    void menu(){
    	System.out.println();
    	System.out.println(" AGENDA");
    	System.out.println(" ======");
    	String opcion="";
    	boolean salir=false;
    	do{
    		System.out.println();
    		opcion=LectorTeclado.pedirCadena(" Introduce OPCION: \n (A)lta \n (C)onsulta \n (M)odificar \n (B)orrar \n Consulta (T)otal \n (G)uardarDatos \n (K)argar Datos \n (S)alir \n opcion...").toUpperCase();
    		if (opcion.length()!=1)
    			opcion="";
    		switch (opcion.charAt(0)){
    			case 'A': 	opcionAlta();
    				 		break;
    			case 'C': 	opcionConsulta();
    				 		break;
    			case 'M': 	opcionModificar();
    				 		break;
    			case 'B':	opcionBorrar();
    						break;
    			case 'T': 	opcionConsultaTotal();
    						break;
    			case 'K': 	opcionCargarDatos();
    						break;
    			case 'G':   opcionSalvarDatos();
    						break;
    			case 'S': 	System.out.println(" Gracias por utilizar nuestra aplicacion Listin");
    						salir=true;
    						break;
    			default:	System.out.println(" Opcion Incorrecta");
    		}
    	}while (!salir);
    }
}